Attribute VB_Name = "modDesktopViewMode"
'This code is founded here: http://www.aboutvb.de/khw/artikel/khwdesktopviewmode.htm
'Thanks for the code!!

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
'Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
'Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long

Private Type StyleBits
    dwOld As Long
    dwNew As Long
End Type

Public Enum ViewModeConstants
    vmIcon
    vmReport
    vmSmallIcon
    vmList
End Enum
Public Const LVS_ICON = &H0
Public Const LVS_REPORT = &H1
Public Const LVS_SMALLICON = &H2
Public Const LVS_LIST = &H3

Public Const S_ICON = "Icon"
Public Const S_LIST = "List"
Public Const S_REPORT = "Report"
Public Const S_SMALL_ICON = "Small Icon"

'Private Const GW_CHILD = 5
Private Const GWL_STYLE = (-16)
Private Const LVS_TYPEMASK = &H3
Private Const WM_STYLECHANGED = &H7D

'Clear Icon Text Background
Private Const CLR_NONE = &HFFFFFFFF
'Private Const COLOR_BACKGROUND = 1
Private Const LVM_FIRST = &H1000 ' ListView messages
Private Const LVM_SETTEXTCOLOR = (LVM_FIRST + 36)
'Private Const LVM_GETTEXTCOLOR = (LVM_FIRST + 35)
'Private Const LVM_SETTEXTBKCOLOR = (LVM_FIRST + 38)
'Private Const LVM_GETTEXTBKCOLOR = (LVM_FIRST + 37)

Private Sub setTextColor()
    Dim lRet As Long
    Dim hwnd As Long
    hwnd = GetSysLVHwnd()
    lRet = SendMessage((hwnd), LVM_SETTEXTCOLOR, 0, CLR_NONE)
End Sub

'Public Sub DesktopViewMode(ViewMode As ViewModeConstants)
Public Sub DesktopViewMode(ViewMode As Long)
    Dim nWnd As Long
    Dim nStyleBits As StyleBits
    
    'nWnd = FindWindow("Progman", "Program Manager")
    'nWnd = GetWindow(nWnd, GW_CHILD)
    'nWnd = GetWindow(nWnd, GW_CHILD)
    nWnd = GetSysLVHwnd()
  
    With nStyleBits
        .dwOld = GetWindowLong(nWnd, GWL_STYLE)
        .dwNew = .dwOld
        .dwNew = .dwNew And Not LVS_TYPEMASK
        .dwNew = .dwNew Or ViewMode
        '.dwNew = ViewMode
        '.dwNew = LVS_REPORT
        '.dwNew = LVS_LIST
    End With
    SendMessage nWnd, WM_STYLECHANGED, GWL_STYLE, nStyleBits
    'set the text color to transparent
    'setTextColor
End Sub

